//Bal - Dragos Oprica
//Complexitate - O (N^5 * logN) - 100
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <vector>
#include <queue>
#include <cmath>
using namespace std;

#define pb push_back
#define mp make_pair
#define sc second
#define fs first

#define INF 2000000000.0
#define DIM 505

ifstream fin ("6-bal.in");
ofstream fout ("6-bal.ok");

vector <pair <int,double> > g[DIM];
double dst[DIM];
double cst_min;

int cap[DIM][DIM],flx[DIM][DIM];
int N,K,SRC,DST;
bool viz[DIM];
int t[DIM];

struct cmp {
  bool operator () (const int &a,const int &b) {
    return dst[a]>dst[b];
  }
}; priority_queue <int,vector <int>,cmp> q;

inline int baiat (int x) {
  return x;
}

inline int fata (int x) {
  return x+N;
}

void read () {
  double x;
  int i,j;

  fin>>N>>K;
  for (i=1; i<=N; ++i)
    for (j=1; j<=N; ++j) {
      fin>>x, x=log (x/100);

      cap[baiat (i)][fata (j)]=1;
      g[baiat (i)].pb (mp (fata (j),-x));
      g[fata (j)].pb (mp (baiat (i),x));
    }
}

int dijkstra () {
  vector <pair <int,double> > :: iterator it;
  int i;

  for (i=SRC; i<=DST; ++i)
    t[i]=-1, dst[i]=INF, viz[i]=0;

  dst[SRC]=0.0, q.push (SRC);
  while (!q.empty ()) {
    i=q.top (), q.pop (), viz[i]=0;

    for (it=g[i].begin (); it!=g[i].end (); ++it)
      if (dst[i]+it->sc<dst[it->fs] && cap[i][it->fs]!=flx[i][it->fs]) {

        t[it->fs]=i;
        dst[it->fs]=dst[i]+it->sc;
        if (!viz[it->fs])
          viz[it->fs]=1, q.push (it->fs);
    }
  }

  if (dst[DST]!=INF)
    return 1;

  return 0;
}

void solve () {
  int i,mtc;

  SRC=0; DST=N+N+1;
  for (i=1; i<=N; ++i) {

    cap[SRC][baiat (i)]=K;
    g[SRC].pb (mp (baiat (i),0));
    g[baiat (i)].pb (mp (SRC,0));

    cap[fata (i)][DST]=1;
    g[fata (i)].pb (mp (DST,0));
    g[DST].pb (mp (fata (i),0));
  }

  for (mtc=1; mtc<=N; ++mtc) {
    if (!dijkstra()) {

      fout<<fixed<<setprecision (6)<<0.0;
      return ;
    }

    for (i=DST; i!=SRC; i=t[i])
      ++flx[t[i]][i], --flx[i][t[i]];
    cst_min+=dst[DST];
  }

  fout<<fixed<<setprecision (6)<<exp (-cst_min)*100;
}

int main () {

  read ();
  solve ();

  return 0;
}
