#include<cstdio>
#include<vector>
#include<deque>
#include<algorithm>

#define infile "triaj.in"
#define outfile "triaj.out"
#define okfile "triaj.ok"

#define infileMsg "Fisier de intrare lipsa!"
#define outfileMsg "Fisier de iesire lipsa!"
#define okfileMsg "Fisier OK lipsa!"
#define okMsg "OK!"
#define partMsg "Punctaj Partial!"
#define wrongMsg "Raspuns Gresit!"

#define pct 5
#define ques 1013

using namespace std;

deque<int> q[ques + 1];
int cnt[ques + 1][2];

void terminate(int p, char *m) {
	printf("%d %s\n", p, m);
	exit(0);
}

bool valid() {

  for(int i = 2; i <= ques; ++i) {
    if(!q[i].empty())
      return false;
  }

  int x = q[1].front();
  q[1].pop_front();

  while(!q[1].empty()) {
    int y = q[1].front();
    q[1].pop_front();
    if(x > y) return false;
    x = y;
  }

  return true;
}

int getPct() {

  int mx = 0;

  for(int i = 1; i <= ques; ++i) {
    mx = max(mx, max(cnt[i][0], cnt[i][1]));
  }

  if(mx <= 1) return pct;
  if(mx <= 2) return pct * 8 / 10;
  if(mx <= 4) return pct * 6 / 10;
  if(mx <= 8) return pct * 4 / 10;
  return pct * 2 / 10;

}

int main() {

  int n, m;

  if(!freopen(infile, "r", stdin))
	  terminate(0, infileMsg);
  if(scanf("%d", &n) != 1)
	  terminate(0, infileMsg);
  for(int i = 1; i <= n; ++i) {
    int x;
    if(scanf("%d", &x) != 1)
      terminate(0, infileMsg);
    q[1].push_back(x);
  }
  fclose(stdin);


  if(!freopen(okfile, "r", stdin))
    terminate(0, okfileMsg);
  fclose(stdin);


  if(!freopen(outfile, "r", stdin))
    terminate(0, outfileMsg);
  if(scanf("%d\n", &m) != 1)
    terminate(0, wrongMsg);


  while(m--) {
    int line, head, t;
    if(scanf("%d %d %d", &line, &head, &t) != 3) terminate(0, wrongMsg);

    if(line < 1 || line > ques) terminate(0, wrongMsg);
    if(head < 0 || head > 1) terminate(0, wrongMsg);
    if(t < 0) terminate(0, wrongMsg);

    ++cnt[line][head];

    while(t--) {
      int nLine, nHead;
      if(scanf("%d %d", &nLine, &nHead) != 2) terminate(0, wrongMsg);

      if(nLine < 1 || nLine > ques) terminate(0, wrongMsg);
      if(nHead < 0 || nHead > 1) terminate(0, wrongMsg);
      if(q[line].empty()) terminate(0, wrongMsg);

      if(nHead == 0) {
        q[nLine].push_front(head == 0 ? q[line].front() : q[line].back());
      } else {
        q[nLine].push_back(head == 0 ? q[line].front() : q[line].back());
      }

      head == 0 ? q[line].pop_front() : q[line].pop_back();

    }

  }

  if(!valid()) terminate(0, wrongMsg);

  int pp = getPct();

  if(pp == pct) terminate(pp, okMsg);
  else terminate(pp, partMsg);

  return 0;
}
